<template>
  <div class="tooltip-wrapper">
    <div class="network-container">
      <div ref="tooltip" class="tooltip" :style="{ ...tooltipPos, opacity: tooltipOpacity }">
        <p class="tooltip-data" v-html="artifactDetails"></p>
      </div>
      <v-network-graph :nodes="nodes" :edges="edges" v-model:layouts="layouts" :event-handlers="eventHandlers"
        class="network-graph" ref="graph">
        <!-- Tooltip -->
      </v-network-graph>
    </div>
    <div v-if="hdaGraphDetails" class="hdaGraph-details">
      <h6>hdaGraph Details</h6>
      <p><strong>IM Version:</strong> {{ hdaGraphDetails.imVersion }}</p>
      <p><strong>ID:</strong> {{ hdaGraphDetails.id }}</p>
      <p><strong>Version:</strong> {{ hdaGraphDetails.version }}</p>
      <p><strong>Designer:</strong> {{ hdaGraphDetails.designer }}</p>
      <p><strong>Intent:</strong> {{ displayedIntent }}</p>
      <p><strong>Description:</strong> {{ hdaGraphDetails.description }}</p>
    </div>
  </div>
</template>

<script setup lang="ts">
console.log('ApplicationNetworkGraphPage is being loaded');

import { computed, ref, watch, onMounted } from 'vue';
import { VNetworkGraph } from 'v-network-graph';
import yaml from 'js-yaml';
import { useFetchDescriptors } from '../hooks/descriptors';
import { useFetchArtifacts } from '../hooks/artifacts';

import { useRouter } from 'vue-router';
import 'v-network-graph/lib/style.css';

const parsedServices = ref([]);
const { descriptor, fetchDescriptor } = useFetchDescriptors();
const { fetchArtifacts } = useFetchArtifacts();

const router = useRouter();
const artifactsVO = ref([]);
const artifactsCVO = ref([]);
const artifactsHelm = ref([]);
const layouts = ref({ nodes: {} });
const hdaGraphDetails = ref(null);

onMounted(async () => {
  var name = router.currentRoute.value.params.name;
  await fetchDescriptor(name);
  artifactsCVO.value = await fetchArtifacts('CVO');
  artifactsVO.value = await fetchArtifacts('VO');
  artifactsHelm.value = await fetchArtifacts('HELM');

  parseDescriptorContent();
});
watch(
  parsedServices,
  (newValue) => {
    if (newValue && newValue.length > 0) {
      layouts.value.nodes = computeLayout(newValue.flat());
    }
  },
  { immediate: true, deep: true },
);

const displayedIntent = computed(() => {
  if (!hdaGraphDetails.value || !hdaGraphDetails.value.hdaGraphIntent) {
    return 'No intent selected';
  }

  const intents = hdaGraphDetails.value.hdaGraphIntent;
  const enabledIntent = Object.keys(intents).find((key) => intents[key].enabled);

  return enabledIntent ? enabledIntent : 'No intent selected';
});

function parseDescriptorContent() {
  const services = [];
  const connectionPoints = [];

  descriptor.value.forEach((desc) => {
    try {
      const parsedContent = yaml.load(desc.content);
      console.log(parsedContent);
      parsedContent.hdaGraph.services.forEach((service) => {
        if (
          service.deployment &&
          service.deployment.intent &&
          service.deployment.intent.connectionPoints
        ) {
          service.deployment.intent.connectionPoints.forEach((cp) => {
            connectionPoints.push({ source: service.id, target: cp });
          });
          services.push({
            id: service.id,
            connectionPoints: service.deployment.intent.connectionPoints,
          });
        } else {
          services.push({ id: service.id, connectionPoints: [] });
        }
      });
      parsedServices.value.push(services);
      hdaGraphDetails.value = parsedContent.hdaGraph;
    } catch (e) {
      console.error('Parsing error:', e);
    }
  });
}
const artifactDetails = computed(() => {
  if (!targetNodeId.value || !nodes.value[targetNodeId.value]?.artifact) {
    return 'No details available';
  }

  const artifact = nodes.value[targetNodeId.value].artifact;
  const detailsHtml = Object.entries(artifact)
    .filter(
      ([key]) =>
        key !== 'description' && key !== 'annotations' && key !== 'maintainers',
    )
    .map(([key, value]) => `${key}: ${value}`)
    .join('<br/>');

  return detailsHtml;
});

const nodes = computed(() => {
  const nodesObj = {};
  parsedServices.value.flat().forEach((service, index) => {
    artifactsVO.value.forEach((artifact) => {
      console.log(artifact.name, service.id, 'VO');
      if (service.id === artifact.name) {
        nodesObj[service.id] = {
          artifact: artifact,

          name: service.id,
          color: `hsl(${index * 90}, 100%, 70%)`,
        };
      }
    });
    artifactsCVO.value.forEach((artifact) => {
      if (service.id === artifact.name) {
        nodesObj[service.id] = {
          artifact: artifact,

          name: service.id,
          color: `hsl(${index * 90}, 100%, 70%)`,
        };
      }
    });
    artifactsHelm.value.forEach((artifact) => {
      if (service.id === artifact.name) {
        nodesObj[service.id] = {
          artifact: artifact,

          name: service.id,
          color: `hsl(${index * 90}, 100%, 70%)`,
        };
      }
    });
  });
  console.log(nodesObj, 'NODES');
  return nodesObj;
});

const edges = computed(() => {
  const edgesObj = {};

  const services = parsedServices.value.flat();

  services.forEach((service) => {
    service.connectionPoints.forEach((connected) => {
      if (connected !== service.id) {
        const edgeId = `edge-${service.id}-${connected}`;
        edgesObj[edgeId] = { source: service.id, target: connected };
      }
    });
  });

  return edgesObj;
});

function computeLayout(services) {
  let layout = {};
  const totalServices = services.length;
  const radius = 100;

  services.forEach((service, index) => {
    const angle = (index / totalServices) * 2 * Math.PI;
    layout[service.id] = {
      x: Math.cos(angle) * radius,
      y: Math.sin(angle) * radius,
    };
  });
  console.log(layout, 'LAYOUT');

  return layout;
}

const graph = ref(null);
const tooltip = ref<HTMLDivElement>(null);
const targetNodeId = ref('');
const tooltipOpacity = ref(0);
const tooltipPos = ref({ left: '200px', top: '100px' });
const tooltipVisible = ref(0);

const eventHandlers = {
  'node:pointerover': ({ node }) => {
    console.log('node:pointerover', node);
    targetNodeId.value = node;
    tooltipOpacity.value = 1;
    tooltipVisible.value = 1;
  },

  'node:pointerout': () => {
    tooltipOpacity.value = 0;
  },
};

const targetNodePos = computed(() => {
  const nodePos = layouts.value.nodes[targetNodeId.value];

  return nodePos || { x: 100, y: 100 };
});

watch(
  () => [targetNodePos.value, tooltipOpacity.value],
  () => {
    if (!graph.value || !tooltip.value) return;

    const domPoint = graph.value.translateFromSvgToDomCoordinates(
      targetNodePos.value,
    );
    console.log('domPoint', domPoint);
    tooltipPos.value = {
      left: domPoint.x - 200 / 2 + 'px',
      top: domPoint.y - 16 - 100 - 10 + 'px',
    };
    console.log(tooltip);
  },
  { deep: true },
);
</script>

<style scoped>
.network-graph {
  width: 100%;
  height: 400px;
}

.graph {
  width: 100%;
  height: 400px;
}

.tooltip {
  top: 0;
  left: 0;
  position: absolute;
  width: 200px;
  height: 100px;
  display: grid;
  place-content: center;
  text-align: center;
  font-size: 12px;
  background-color: #fff0bd;
  border: 1px solid #ffb950;
  box-shadow: 2px 2px 2px #aaa;
  transition: opacity 0.2s linear;
  pointer-events: none;
  padding: 10px;
  z-index: 1000;
}

.node-details {
  padding: 20px;
  border: 1px solid black;
  margin-top: 20px;
}

.tooltip-data {
  display: flex;
  justify-content: center;
  align-items: center;
  width: 200px;
  height: 100px;
  padding: 10px;
}

.tooltip-wrapper {
  display: flex;
  position: relative;
  justify-content: space-between;
}

.network-container {
  width: 50%;
}

.hdaGraph-details {
  width: 35%;
  margin-left: 20px;
  padding: 20px;
  border: 1px solid #ccc;
  border-radius: 8px;
}
</style>
